import _slicedToArray from '@babel/runtime/helpers/slicedToArray';
import _objectWithoutProperties from '@babel/runtime/helpers/objectWithoutProperties';
import { useState, useEffect } from 'react';
import { EdsProvider, Input, Autocomplete } from '@equinor/eds-core-react';
import { jsx } from 'react/jsx-runtime';

var _excluded = ["value", "values", "onChange", "debounce"];
// File ignored, as relevant actions are covered via Filter.test.tsx
function DebouncedInput(_ref) {
  var _props$placeholder, _props$placeholder2;
  var initialValue = _ref.value,
    values = _ref.values,
    onChange = _ref.onChange,
    _ref$debounce = _ref.debounce,
    debounce = _ref$debounce === void 0 ? 500 : _ref$debounce,
    props = _objectWithoutProperties(_ref, _excluded);
  var _useState = useState(initialValue),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  useEffect(function () {
    setValue(initialValue);
  }, [initialValue]);
  useEffect(function () {
    var timeout = setTimeout(function () {
      onChange(value);
    }, debounce);
    return function () {
      return clearTimeout(timeout);
    };
    // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [value]);
  return /*#__PURE__*/jsx(EdsProvider, {
    density: "compact",
    children: props.type === 'number' ? /*#__PURE__*/jsx(Input, {
      type: 'number',
      placeholder: (_props$placeholder = props.placeholder) !== null && _props$placeholder !== void 0 ? _props$placeholder : 'Search',
      value: value,
      onChange: function onChange(e) {
        return setValue(e.target.valueAsNumber);
      }
    }) : /*#__PURE__*/jsx(Autocomplete, {
      options: values,
      multiple: true,
      optionComponent: function optionComponent(opt) {
        return opt === 'NULL_OR_UNDEFINED' ? '<Blank>' : opt;
      },
      "data-testid": 'autocomplete'
      /* eslint-disable-next-line @typescript-eslint/ban-ts-comment */
      // @ts-ignore
      ,
      label: null,
      placeholder: (_props$placeholder2 = props.placeholder) !== null && _props$placeholder2 !== void 0 ? _props$placeholder2 : 'Search',
      onOptionsChange: function onOptionsChange(c) {
        return setValue(c.selectedItems);
      }
    })
  });
}

export { DebouncedInput };
