import { useMemo } from 'react';
import { DebouncedInput } from './DebouncedInput.js';
import { jsxs, jsx } from 'react/jsx-runtime';

/* istanbul ignore file */

function Filter(_ref) {
  var _table$getPreFiltered, _column$getFacetedMin, _column$getFacetedMin2, _column$getFacetedMin3, _column$getFacetedMin4, _, _column$getFacetedMin5, _column$getFacetedMin6, _column$getFacetedMin7, _column$getFacetedMin8, _column$getFacetedMin9, _column$getFacetedMin10, _2, _column$getFacetedMin11, _column$getFacetedMin12;
  var column = _ref.column,
    table = _ref.table;
  var firstValue = (_table$getPreFiltered = table.getPreFilteredRowModel().flatRows[0]) === null || _table$getPreFiltered === void 0 ? void 0 : _table$getPreFiltered.getValue(column.id);
  var columnFilterValue = column.getFilterValue();
  var sortedUniqueValues = useMemo(function () {
    return typeof firstValue === 'number' ? [] : Array.from(column.getFacetedUniqueValues().keys()).sort().map(function (v) {
      return v !== null && v !== void 0 ? v : 'NULL_OR_UNDEFINED';
    });
  },
  // eslint-disable-next-line react-hooks/exhaustive-deps
  [column.getFacetedUniqueValues()]);
  return typeof firstValue === 'number' ? /*#__PURE__*/jsxs("div", {
    children: [/*#__PURE__*/jsx(DebouncedInput, {
      type: "number",
      values: sortedUniqueValues,
      min: Number((_column$getFacetedMin = (_column$getFacetedMin2 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin2 === void 0 ? void 0 : _column$getFacetedMin2[0]) !== null && _column$getFacetedMin !== void 0 ? _column$getFacetedMin : ''),
      max: Number((_column$getFacetedMin3 = (_column$getFacetedMin4 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin4 === void 0 ? void 0 : _column$getFacetedMin4[1]) !== null && _column$getFacetedMin3 !== void 0 ? _column$getFacetedMin3 : ''),
      value: (_ = columnFilterValue === null || columnFilterValue === void 0 ? void 0 : columnFilterValue[0]) !== null && _ !== void 0 ? _ : '',
      onChange: function onChange(value) {
        return column.setFilterValue(function (old) {
          return [value, old === null || old === void 0 ? void 0 : old[1]];
        });
      },
      placeholder: "Min ".concat((_column$getFacetedMin5 = column.getFacetedMinMaxValues()) !== null && _column$getFacetedMin5 !== void 0 && _column$getFacetedMin5[0] ? "(".concat((_column$getFacetedMin6 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin6 === void 0 ? void 0 : _column$getFacetedMin6[0], ")") : '')
    }), /*#__PURE__*/jsx(DebouncedInput, {
      type: "number",
      values: sortedUniqueValues,
      min: Number((_column$getFacetedMin7 = (_column$getFacetedMin8 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin8 === void 0 ? void 0 : _column$getFacetedMin8[0]) !== null && _column$getFacetedMin7 !== void 0 ? _column$getFacetedMin7 : ''),
      max: Number((_column$getFacetedMin9 = (_column$getFacetedMin10 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin10 === void 0 ? void 0 : _column$getFacetedMin10[1]) !== null && _column$getFacetedMin9 !== void 0 ? _column$getFacetedMin9 : ''),
      value: (_2 = columnFilterValue === null || columnFilterValue === void 0 ? void 0 : columnFilterValue[1]) !== null && _2 !== void 0 ? _2 : '',
      onChange: function onChange(value) {
        return column.setFilterValue(function (old) {
          return [old === null || old === void 0 ? void 0 : old[0], value];
        });
      },
      placeholder: "Max ".concat((_column$getFacetedMin11 = column.getFacetedMinMaxValues()) !== null && _column$getFacetedMin11 !== void 0 && _column$getFacetedMin11[1] ? "(".concat((_column$getFacetedMin12 = column.getFacetedMinMaxValues()) === null || _column$getFacetedMin12 === void 0 ? void 0 : _column$getFacetedMin12[1], ")") : '')
    })]
  }) : /*#__PURE__*/jsx(DebouncedInput, {
    type: "text",
    values: sortedUniqueValues,
    value: columnFilterValue !== null && columnFilterValue !== void 0 ? columnFilterValue : '',
    onChange: function onChange(value) {
      return column.setFilterValue(value);
    },
    placeholder: "Search (".concat(column.getFacetedUniqueValues().size, ")"),
    list: column.id + 'list'
  });
}

export { Filter };
