import _objectSpread from '@babel/runtime/helpers/objectSpread2';
import { flexRender } from '@tanstack/react-table';
import { Table, Typography } from '@equinor/eds-core-react';
import { useTableContext } from '../EdsDataGridContext.js';
import { jsx } from 'react/jsx-runtime';

function TableBodyCell(_ref) {
  var _cellStyle;
  var cell = _ref.cell;
  var _useTableContext = useTableContext(),
    cellClass = _useTableContext.cellClass,
    cellStyle = _useTableContext.cellStyle;
  return /*#__PURE__*/jsx(Table.Cell, {
    className: cellClass ? cellClass(cell.row, cell.column.id) : '',
    key: cell.id,
    style: _objectSpread({
      width: cell.column.getSize(),
      maxWidth: cell.column.getSize(),
      overflow: 'hidden',
      whiteSpace: 'nowrap',
      textOverflow: 'ellipsis'
    }, (_cellStyle = cellStyle === null || cellStyle === void 0 ? void 0 : cellStyle(cell.row, cell.column.id)) !== null && _cellStyle !== void 0 ? _cellStyle : {}),
    children: /*#__PURE__*/jsx(Typography, {
      as: "span",
      group: "table",
      variant: "cell_text",
      children: flexRender(cell.column.columnDef.cell, cell.getContext())
    })
  });
}

export { TableBodyCell };
