import _objectSpread from '@babel/runtime/helpers/objectSpread2';
import { Table } from '@equinor/eds-core-react';
import { TableBodyCell } from './TableBodyCell.js';
import { useTableContext } from '../EdsDataGridContext.js';
import { jsx } from 'react/jsx-runtime';

function TableRow(_ref) {
  var _rowStyle;
  var row = _ref.row;
  var _useTableContext = useTableContext(),
    rowClass = _useTableContext.rowClass,
    rowStyle = _useTableContext.rowStyle;
  return /*#__PURE__*/jsx(Table.Row, {
    style: _objectSpread({
      cursor: row.getCanSelect() ? 'pointer' : 'inherit'
    }, (_rowStyle = rowStyle === null || rowStyle === void 0 ? void 0 : rowStyle(row)) !== null && _rowStyle !== void 0 ? _rowStyle : {}),
    className: "".concat(row.getIsSelected() ? 'selected' : '', " ").concat(rowClass === null || rowClass === void 0 ? void 0 : rowClass(row)),
    onClick: function onClick() {
      return row.getCanSelect() ? row.toggleSelected() : null;
    },
    children: row.getVisibleCells().map(function (cell) {
      return /*#__PURE__*/jsx(TableBodyCell, {
        cell: cell
      }, cell.id);
    })
  });
}

export { TableRow };
