import { CSSProperties, ReactElement } from 'react';
import { Column, Row, Table as TanStackTable } from '@tanstack/react-table';
type Context<T> = {
    enableSorting: boolean;
    stickyHeader: boolean;
    enableColumnFiltering: boolean;
    table: TanStackTable<T> | null;
    cellClass?: (row: Row<T>, columnId: string) => string;
    rowClass?: (row: Row<T>) => string;
    cellStyle?: (row: Row<T>, columnId: string) => CSSProperties;
    rowStyle?: (row: Row<T>) => CSSProperties;
    headerClass?: (column: Column<T>) => string;
    headerStyle?: (column: Column<T>) => CSSProperties;
};
export declare const EdsDataGridContext: import("react").Context<Context<any>>;
export declare function TableProvider<T>({ children, ...props }: Context<T> & {
    children: ReactElement | Array<ReactElement>;
}): JSX.Element;
export declare const useTableContext: () => Context<any>;
export {};
